<template>
    <div>
        <div class="settings_block">
            <div class="settings_block__content flex-wrap">
                <div
                    v-if="items.fromName !== null"
                    class="col-12 col-xl-6 settings_block__item"
                >
                    <div class="title">
                        From name
                    </div>
                    <validation-element
                        v-model="items.fromName"
                        name="from_name"
                        placeholder="From name"
                        custom-input-class="input_blue"
                        @input="save()"
                    />
                    <span class="desc">
                        *The name visible to customers receiving your email.
                    </span>
                </div>
                <!-- <div class="col-12 col-xl-4 settings_block__item">
                  <div class="title">From email</div>
                  <validation-element
                    v-model="items.fromEmail"
                    name="from_email"
                    ref="from_email"
                    rules="required|email"
                    customInputClass="input_blue"
                    placeholder="From email"
                  />
                  <span class="desc">
                    *The email name visible to customers receiving your email.
                  </span>
                </div> -->
                <div class="col-12 col-xl-6 settings_block__item">
                    <div class="title">
                        Reply to email
                    </div>
                    <validation-element
                        v-model="items.replyEmail"
                        name="reply_email"
                        rules="email"
                        custom-input-class="input_blue"
                        placeholder="Reply to email"
                        @input="save()"
                    />
                    <span class="desc">
                        *The email that the replies of your customers will be sent to.
                    </span>
                </div>
            </div>
        </div>

        <Notify
            :domain="{ value: items.domain, active: items.active }"
            :loading="loading"
            :from-email="items.fromEmail"
            @startLoad="startLoad"
            @clearLoads="clearLoads"
            @clearFromEmail="clearFromEmail"
            @updFromEmail="updFromEmail($event), $event ? save() : null"
        />

        <div class="settings_block">
            <div class="settings_block__content flex-wrap">
                <div class="col-12 col-xl-6 settings_block__item safe_send">
                    <div class="title">
                        Safe Send
                        <b-form-checkbox
                            v-model="items.safeSendEmail.isActive"
                            class="switcher"
                            switch
                            size="lg"
                            @input="$emit('saveSwitch', {type: 'email', key: 'safeSendEmail', name: 'Safe send'})"
                        />
                    </div>
                    <span class="desc desc__safe_send mb-3">
                        *If you turn it on, the messages will be not sent to the customers that received an email from you in the last X hours:
                    </span>
                    <SafeSend
                        v-if="items.safeSendEmail.isActive"
                        v-model="items.safeSendEmail.value"
                        :type="items.safeSendEmail.type"
                        :default="6"
                        @updType="items.safeSendEmail.type = $event, save()"
                        @input="save()"
                    />
                    <b-form-group
                        v-if="items.safeSendEmail.isActive"
                        style="margin-top: 15px; margin-bottom: 0;"
                    >
                        <b-form-radio-group
                            v-model="items.safeSendEmail.skip"
                            name="radios-stacked"
                            plain
                            stacked
                            button-variant="outline-secondary"
                            size="lg"
                            :options="safeSendSkipOptions"
                            @change="save()"
                        />
                    </b-form-group>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import {settings} from "@/mixins/settings";
import ValidationElement from "@/components/elements/ValidationElement";
import SafeSend from "@/components/settings/tabs/sms/SafeSend";
import Notify from "./email/Notify.vue";

export default {
    components: {
        ValidationElement,
        Notify,
        SafeSend,
    },
    mixins: [settings],
    props: ["settings"],
    data() {
        return {
            items: {
                fromName: "",
                fromEmail: "",
                replyEmail: "",
                safeSendEmail: {
                    isActive: false,
                    value: "",
                    type: "",
                },
                domain: "",
                active: false,
            },
            safeSendSkipOptions: [
                {text: 'Queue the reminder that is scheduled to the safe send hours', value: false,},
                {text: 'Skip the reminder that is scheduled to the safe send hours', value: true},
            ],
            loading: {
                cnames: false,
                verify: false,
                save: false,
            },
        };
    },
    created() {
        this.getData();
    },
    methods: {
        save(type) {
            const emitObj = {
                items: this.items
            }
            if(type) emitObj.type = 'changeTab'
            this.$emit("save", emitObj);
        },
        clearLoads() {
            for (const key in this.loading) {
                if (this.loading[key]) this.loading[key] = false
            }
        },
        clearFromEmail() {
            this.updFromEmail('')
        },
        async updFromEmail(email) {
            this.items.fromEmail = email
            if (email) {
                this.showSafeSend = true
                this.$emit('saveFromEmail', this.items)
            } else this.save()
        },
        startLoad(key) {
            if (!this.loading[key]) this.loading[key] = true;
        },
    },
};
</script>

<style lang="scss" scoped>
@import "../../../../css/settings/index.scss";

// @media (min-width: 768px) {
//   .settings_block {
//     &__content {
//       padding-right: 34px;
//       padding-left: 34px;
//     }
//   }
// }
@media(max-width: 1150px) {
    .settings_block__item {
        &.safe_send {
            margin-bottom: 0;
            padding: 0 15px;
        }
    }
}

.settings_block .desc__safe_send {
    width: 310px;
}
</style>

<style lang="scss">
.tooltip-inner {
    max-width: 327px;
    font-size: 14px;
    line-height: 21px;
    padding: 20px 42px 17px 20px;
    font-weight: 400;
    color: #000000;
    font-family: 'Roboto';
}
.bs-tooltip-top .arrow::before, .bs-tooltip-auto[x-placement^="top"] .arrow::before {
    border-top-color: transparent;
}


</style>
